program DobbelSimulatie;
  { Lees aantal rondes in en simuleer ze.
    Per ronde: werp per speler, bepaal winnaar, d.w.z. werper van unieke
      maximum dan wel nieman als maximum niet uniek is.
    Druk af hoe vaak elke speler en niemand gewonnen heeft. }

//# BEGIN TODO Voltooid door: Auteur, id.nr., datum
  Replace this line by your text.
//# END TODO

const
  NSpelers = 5; { aantal spelers, 1 <= NSpelers }
  Niemand = 0; { fictieve speler, aanduiding als niemand wint }
  MinWaarde = 1; { minimale worpwaarde }
  MaxWaarde = 12; { maximale worpwaarde }

type
  Speler = Niemand .. NSpelers; { de spelers, inclusief fictieve }
  Waarde = MinWaarde .. MaxWaarde; { worpwaarden }
  WorpLijst = array [ 1 .. NSpelers ] of Waarde; { worp per speler }

procedure Werp ( out wl: WorpLijst );
  { pre:  True
    post: wl[i] bevat random worp, waarbij
      speler 1 met dodecaeder werpt en
      de overige spelers met twee gewone dobbelstenen }
  var
    i: Speler; { doorloopt wl }
  begin
//# BEGIN TODO: body van Werp
  Replace this line by your text.
//# END TODO
  end; { Werp }

function MaxWorp ( const wl: WorpLijst ): Waarde;
  { pre: True
    ret: maximum van wl }
  var
    i: Speler; { doorloopt wl }
  begin
//# BEGIN TODO: body van MaxWorp
  Replace this line by your text.
//# END TODO
  end; { MaxWorp }

function AantalWorp ( const wl: WorpLijst; w: Waarde ): Integer;
  { pre: True
    ret: (# i: 1 <= i <= NSpelers: wl[i] = w) }
  var
    i: Speler; { doorloopt wl }
  begin
//# BEGIN TODO: body van AantalWorp
  Replace this line by your text.
//# END TODO
  end; { AantalWorp }

function WieWerpt ( const wl: WorpLijst; w: Waarde ): Speler;
  { pre: w komt voor in wl
    ret: s met wl [ s ] = w }
  begin
//# BEGIN TODO: body van WieWerpt
  Replace this line by your text.
//# END TODO
  end; { WieWerpt }

procedure SimuleerRonde ( out s: Speler );
  { pre:  True
    post: s is winnaar van gesimuleerde ronde }

  var
    worp: WorpLijst;  { om alle worpen op te slaan }
    max: Waarde; { maximum van worp[...] }
    telMax: Integer; { aantal keer dat maximum voorkomt in worp[...] }
    maxWerper: Speler; { wie max wierp }

  begin
//# BEGIN TODO: body van SimuleerRonde
  Replace this line by your text.
//# END TODO
  end; { SimuleerRonde }

type
  WinstTelling = array [ Speler ] of Cardinal; { telling per speler }

procedure InitWinstTelling ( out wt: WinstTelling; v: Cardinal );
  { pre:  True
    post: wt[i] = v voor alle i }
  var
    i: Speler; { doorloopt wt }
  begin
//# BEGIN TODO: body van InitWinstTelling
  Replace this line by your text.
//# END TODO
  end; { InitWinstTelling }

procedure SchrijfWinstTelling ( var f: TextFile; const wt: WinstTelling );
  { pre: f is geopend om te schrijven
    post: wt is geschreven naar f in de volgorde speler 1 t/m NSpelers,
      gevolgd door Niemand, gescheiden door een spatie }
  var
    i: Speler; { doorloopt wt }
  begin
//# BEGIN TODO: body van SchrijfWinstTelling
  Replace this line by your text.
//# END TODO
  end; { SchrijfWinstTelling }

var { globale variabelen }
  aantalRondes: Cardinal; { aantal te simuleren rondes (invoer) }
  rondeNummer: Cardinal; { doorloopt rondes }
  winst: WinstTelling; { winstellingen (uitvoer) }
    { winst[i] = aantal keer dat speler i wint }
  winnaar: Speler; { winnaar van ronde }

begin
  readln ( aantalRondes )
; Randomize
; InitWinstTelling ( winst, 0 )

; for rondeNummer := 1 to aantalRondes do begin
    SimuleerRonde ( winnaar )
  ; Inc ( winst [ winnaar ] )
  end { for rondeNummer }

; SchrijfWinstTelling ( output, winst )
end.
